import socket

from twisted.python import log
from buildbot.buildslave import BuildSlave
from boto.ec2.connection import EC2Connection
from boto.resultset import ResultSet

class EC2BuildSlave(BuildSlave):
	"""This is the master-side representative for a remote buildbot slave
	on an EC2 instance, running on the Amazon EC2 service."""
	
	def __init__(self, name, password, public, private, dns, instance="ami-4d26c324", max_builds=None, notify_on_missing=[], missing_timeout=3600):
		BuildSlave.__init__(self, name, password, max_builds=None, notify_on_missing=[], missing_timeout=3600)
		log.msg("EC2BuildSlave loaded.")
		self.connect(public, private, dns, instance)
		
	def connect(self, public, private, dns, instance):
		self.conn = EC2Connection(public, private)
		self.conn.run_instances(instance, 1, 1, "gsg-keypair", "", dns)